<template>
	<div class="q-pa-md q-gutter-sm">
		<q-dialog v-model="userChangePwd" class="dialog">
			<q-card style="width: 500px;">
				<div class="row">
					<q-card-section>
						<div class="text-h6">Change password</div>
					</q-card-section>
					<q-space />
					<q-card-section>
						<q-btn round dense icon="close" v-close-popup />
					</q-card-section>
				</div>

				<q-card-section class="q-pt-none">
					<div>Change password of {{ userName }}</div>
					<br />
					<q-input
						outlined
						v-model="newPwd"
						label="New password"
						type="password"
						ref="newPwd"
					/><br />
					<q-input
						outlined
						v-model="confirmPwd"
						label="Confirm password"
						type="password"
						ref="confirmPwd"
					/>
					<div class="q-pa-md q-gutter-sm">
						<q-dialog
							v-model="alert"
							persistent
							transition-show="scale"
							transition-hide="scale"
						>
							<q-card
								class="text-white"
								style="width: 300px;"
								:style="{ background: bgColor }"
							>
								<q-card-section>
									<div class="text-h6">{{ errorTitle }}</div>
								</q-card-section>

								<q-card-section class="q-pt-none">
									{{ message }}
								</q-card-section>

								<q-card-actions
									align="right"
									class="bg-white text-teal"
								>
									<q-btn flat label="OK" v-close-popup />
								</q-card-actions>
							</q-card>
						</q-dialog>
					</div>
					<q-btn
						style="width: 100%;"
						label="Change"
						color="primary"
						type="button"
						@click="ChangePwd"
					/>
				</q-card-section>
			</q-card>
		</q-dialog>
	</div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";
export default {
	data() {
		return {
			newPwd: null,
			confirmPwd: null,
			// alert
			alert: false,
			message: null,
			errorTitle: null,
			bgColor: null,
		};
	},
	methods: {
		ChangePwd() {
			this.$refs.newPwd.validate();
			this.$refs.confirmPwd.validate();
			if (
				!this.$refs.newPwd.hasError &&
				!this.$refs.confirmPwd.hasError
			) {
				this.$axios
					.put(this.host + "/src/php/actions/user.php", {
						action: "change-pwd",
						userId: this.userId,
						newPwd: this.newPwd,
						confirmPwd: this.confirmPwd,
					})
					.then((response) => {
						if (response.data.error) {
							this.message = response.data.message;
							this.errorTitle = response.data.title;
							this.bgColor = "red";
						} else {
							this.message = response.data.message;
							this.errorTitle = response.data.title;
							this.bgColor = "green";
							this.newPwd = "";
							this.confirmPwd = "";
						}
					});
				this.alert = true;
			}
		},
		// ...mapActions({
		// 	userName: "showcase/userName",
		// }),
	},
	computed: {
		...mapGetters({
			changePwd: "showcase/userChangePwd",
			userId: "showcase/userId",
			userName: "showcase/userName",
		}),
		userChangePwd: {
			get() {
				return this.changePwd;
			},
			set(val) {
				this.$store.commit("showcase/hideUserChangePwdForm", val);
			},
		},
	},
};
</script>
